#ifndef OSGRDESTL_ALLOCATOR_H
#define OSGRDESTL_ALLOCATOR_H

#include <cstring>

#include "OSGBase.h"

namespace osgrde
{

// CONCEPT!
class OSG_BASE_DLLMAPPING allocator
{
public:
	explicit allocator(const char* name = "DEFAULT");
	// Copy ctor generated by compiler.
	//allocator(const allocator&)
	~allocator();

	// Generated by compiler.
	//allocator& operator=(const allocator&)

	void* allocate(size_t bytes, int flags = 0);
	//void* allocate_aligned(size_t bytes, size_t alignment, int flags = 0);
	void deallocate(void* ptr, size_t bytes);

	const char* get_name() const;

private:
	const char*	m_name;
};

// True if lhs can free memory allocated by rhs and vice-versa.
inline bool operator==(const allocator& /*lhs*/, const allocator& /*rhs*/)
{
	return true;
}
inline bool operator!=(const allocator& lhs, const allocator& rhs)
{
	return !(lhs == rhs);
}

inline void* allocator::allocate(size_t bytes, int)
{
	return operator new(bytes);
}

inline void allocator::deallocate(void* ptr, size_t)
{
	operator delete(ptr);
}

inline const char* allocator::get_name() const
{
	return m_name;
}

} // namespace osgrde

//-----------------------------------------------------------------------------
#endif // #ifndef OSGRDESTL_ALLOCATOR_H
