/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *             Copyright (C) 2000-2002 by the OpenSG Forum                   *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

#ifndef _OSGQ4ATTACHMENTMAPEDITOR_QT_H_
#define _OSGQ4ATTACHMENTMAPEDITOR_QT_H_
#ifdef __sgi
#pragma once
#endif

#include <OSGConfig.h>
#include <OSGWindowQT4Def.h>
#include <OSGQ4AbstractValueEditor_qt.h>
#include <OSGAttachment.h>

#include <vector>
//Added by qt3to4:
#include <Q3GridLayout>
#include <QLabel>

class QLabel;
class Q3GridLayout;

OSG_BEGIN_NAMESPACE
    
class QFieldContainerPtrEditor;

class OSG_WINDOWQTLIB_DLLMAPPING QAttachmentMapEditor 
    : public QAbstractValueEditor
{
    Q_OBJECT
        
  public:
    static QAbstractValueEditor *create(QWidget *pParent, const char *name);

             QAttachmentMapEditor(QWidget *pParent, const char *name);
    virtual ~QAttachmentMapEditor(void                              );
        
    inline void getValue(      AttachmentMap &attMap) const;
    inline void setValue(const AttachmentMap &attMap);

    inline const QFieldContainerPtrEditor *getEditor(UInt32 index) const;
    inline       QFieldContainerPtrEditor *getEditor(UInt32 index); 

  public slots:
    virtual void setLabelsVisible(bool bLabels  );
    virtual void setReadOnly     (bool bReadOnly);

    virtual void readField      (FieldContainerPtr pFC,          
                                 UInt32            uiFieldId,
                                 UInt32            uiValueIndex,
                                 UInt32            uiAspect     );
    virtual void readField      (FieldContainerPtr pFC,
                                 UInt32            uiFieldId,
                                 UInt32            uiValueIndex );

    virtual void writeField     (FieldContainerPtr pFC,
                                 UInt32            uiFieldId,
                                 UInt32            uiValueIndex );

    virtual void addFieldElem   (FieldContainerPtr pFC,
                                 UInt32            uiFieldId,
                                 UInt32            uiValueIndex );
    virtual void removeFieldElem(FieldContainerPtr pFC,
                                 UInt32            uiFieldId,
                                 UInt32            uiValueIndex );
    
 protected slots:
    virtual void slotValueChanged  (QAbstractValueEditor *pSender                 );
    virtual void slotGenericRequest(QAbstractValueEditor *pSender, QString request);

  private:
    typedef QAbstractValueEditor Inherited;
      
    /*!\brief prohibit default function (move to 'public' if needed) */
    QAttachmentMapEditor (const QAttachmentMapEditor &source);
    /*!\brief prohibit default function (move to 'public' if needed) */
    void operator= (const QAttachmentMapEditor &source);
  
    void createChildWidgets(void);
    void layoutChildWidgets(void);
    void initSelf          (void);
      
    void updateDisplay     (const AttachmentMap &attMap);
    void updateData        (      AttachmentMap &attMap) const;
    
    std::vector<QLabel                   *>  _indexLabels;
    std::vector<QLabel                   *>  _groupLabels;
    std::vector<QFieldContainerPtrEditor *>  _attachmentEditors;
    
    Q3GridLayout                             *_pGrid;
};

OSG_END_NAMESPACE

#include "OSGQ4AttachmentMapEditor_qt.inl"

#define OSGQ4ATTACHMENTMAPEDITORQT_HEADER_CVSID "@(#)$Id: OSGQ4AttachmentMapEditor_qt.h,v 1.1 2004/12/20 11:09:52 neumannc Exp $"

#endif /* _OSGQ4ATTACHMENTMAPEDITOR_QT_H_ */
