/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class Transform3D
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGTRANSFORM3DBASE_H_
#define _OSGTRANSFORM3DBASE_H_
#ifdef __sgi
#pragma once
#endif


#include <OSGConfig.h>
#include <OSGSystemDef.h>

#include <OSGBaseTypes.h>
#include <OSGRefPtr.h>
#include <OSGCoredNodePtr.h>

#include <OSGTransform.h> // Parent

#include <OSGVec3fFields.h> // Translation type
#include <OSGVec3fFields.h> // EulerRotation type
#include <OSGVec3fFields.h> // Scale type
#include <OSGQuaternionFields.h> // Rotation type
#include <OSGVec3fFields.h> // Shear type
#include <OSGPnt3fFields.h> // ScalePivot type
#include <OSGVec3fFields.h> // ScalePivotTranslation type
#include <OSGPnt3fFields.h> // RotatePivot type
#include <OSGVec3fFields.h> // RotatePivotTranslation type
#include <OSGQuaternionFields.h> // RotationOrientation type
#include <OSGPnt3fFields.h> // Center type
#include <OSGUInt32Fields.h> // RotationMode type
#include <OSGReal64Fields.h> // Version type
#include <OSGVec3fFields.h> // EulerRotationOrientation type
#include <OSGStringFields.h> // EulerRotationOrder type
#include <OSGUInt64Fields.h> // Flags type

#include <OSGTransform3DFields.h>

OSG_BEGIN_NAMESPACE

class Transform3D;
class BinaryDataHandler;

//! \brief Transform3D Base Class.

class OSG_SYSTEMLIB_DLLMAPPING Transform3DBase : public Transform
{
  private:

    typedef Transform    Inherited;

    /*==========================  PUBLIC  =================================*/
  public:

    typedef Transform3DPtr  Ptr;

    enum
    {
        TranslationFieldId              = Inherited::NextFieldId,
        EulerRotationFieldId            = TranslationFieldId              + 1,
        ScaleFieldId                    = EulerRotationFieldId            + 1,
        RotationFieldId                 = ScaleFieldId                    + 1,
        ShearFieldId                    = RotationFieldId                 + 1,
        ScalePivotFieldId               = ShearFieldId                    + 1,
        ScalePivotTranslationFieldId    = ScalePivotFieldId               + 1,
        RotatePivotFieldId              = ScalePivotTranslationFieldId    + 1,
        RotatePivotTranslationFieldId   = RotatePivotFieldId              + 1,
        RotationOrientationFieldId      = RotatePivotTranslationFieldId   + 1,
        CenterFieldId                   = RotationOrientationFieldId      + 1,
        RotationModeFieldId             = CenterFieldId                   + 1,
        VersionFieldId                  = RotationModeFieldId             + 1,
        EulerRotationOrientationFieldId = VersionFieldId                  + 1,
        EulerRotationOrderFieldId       = EulerRotationOrientationFieldId + 1,
        FlagsFieldId                    = EulerRotationOrderFieldId       + 1,
        NextFieldId                     = FlagsFieldId                    + 1
    };

    static const OSG::BitVector TranslationFieldMask;
    static const OSG::BitVector EulerRotationFieldMask;
    static const OSG::BitVector ScaleFieldMask;
    static const OSG::BitVector RotationFieldMask;
    static const OSG::BitVector ShearFieldMask;
    static const OSG::BitVector ScalePivotFieldMask;
    static const OSG::BitVector ScalePivotTranslationFieldMask;
    static const OSG::BitVector RotatePivotFieldMask;
    static const OSG::BitVector RotatePivotTranslationFieldMask;
    static const OSG::BitVector RotationOrientationFieldMask;
    static const OSG::BitVector CenterFieldMask;
    static const OSG::BitVector RotationModeFieldMask;
    static const OSG::BitVector VersionFieldMask;
    static const OSG::BitVector EulerRotationOrientationFieldMask;
    static const OSG::BitVector EulerRotationOrderFieldMask;
    static const OSG::BitVector FlagsFieldMask;


    static const OSG::BitVector MTInfluenceMask;

    /*---------------------------------------------------------------------*/
    /*! \name                    Class Get                                 */
    /*! \{                                                                 */

    static        FieldContainerType &getClassType    (void); 
    static        UInt32              getClassTypeId  (void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                FieldContainer Get                            */
    /*! \{                                                                 */

    virtual       FieldContainerType &getType  (void); 
    virtual const FieldContainerType &getType  (void) const; 

    virtual       UInt32              getContainerSize(void) const;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Get                                 */
    /*! \{                                                                 */


           SFVec3f             *editSFTranslation    (void);
     const SFVec3f             *getSFTranslation    (void) const;
#ifndef OSG_2_PREP
           SFVec3f             *getSFTranslation    (void);
#endif

           SFVec3f             *editSFEulerRotation  (void);
     const SFVec3f             *getSFEulerRotation  (void) const;
#ifndef OSG_2_PREP
           SFVec3f             *getSFEulerRotation  (void);
#endif

           SFVec3f             *editSFScale          (void);
     const SFVec3f             *getSFScale          (void) const;
#ifndef OSG_2_PREP
           SFVec3f             *getSFScale          (void);
#endif

           SFQuaternion        *editSFRotation       (void);
     const SFQuaternion        *getSFRotation       (void) const;
#ifndef OSG_2_PREP
           SFQuaternion        *getSFRotation       (void);
#endif

           SFVec3f             *editSFShear          (void);
     const SFVec3f             *getSFShear          (void) const;
#ifndef OSG_2_PREP
           SFVec3f             *getSFShear          (void);
#endif

           SFPnt3f             *editSFScalePivot     (void);
     const SFPnt3f             *getSFScalePivot     (void) const;
#ifndef OSG_2_PREP
           SFPnt3f             *getSFScalePivot     (void);
#endif

           SFVec3f             *editSFScalePivotTranslation(void);
     const SFVec3f             *getSFScalePivotTranslation(void) const;
#ifndef OSG_2_PREP
           SFVec3f             *getSFScalePivotTranslation(void);
#endif

           SFPnt3f             *editSFRotatePivot    (void);
     const SFPnt3f             *getSFRotatePivot    (void) const;
#ifndef OSG_2_PREP
           SFPnt3f             *getSFRotatePivot    (void);
#endif

           SFVec3f             *editSFRotatePivotTranslation(void);
     const SFVec3f             *getSFRotatePivotTranslation(void) const;
#ifndef OSG_2_PREP
           SFVec3f             *getSFRotatePivotTranslation(void);
#endif

           SFQuaternion        *editSFRotationOrientation(void);
     const SFQuaternion        *getSFRotationOrientation(void) const;
#ifndef OSG_2_PREP
           SFQuaternion        *getSFRotationOrientation(void);
#endif

           SFPnt3f             *editSFCenter         (void);
     const SFPnt3f             *getSFCenter         (void) const;
#ifndef OSG_2_PREP
           SFPnt3f             *getSFCenter         (void);
#endif

           SFUInt32            *editSFRotationMode   (void);
     const SFUInt32            *getSFRotationMode   (void) const;
#ifndef OSG_2_PREP
           SFUInt32            *getSFRotationMode   (void);
#endif

           SFReal64            *editSFVersion        (void);
     const SFReal64            *getSFVersion        (void) const;
#ifndef OSG_2_PREP
           SFReal64            *getSFVersion        (void);
#endif

           SFVec3f             *editSFEulerRotationOrientation(void);
     const SFVec3f             *getSFEulerRotationOrientation(void) const;
#ifndef OSG_2_PREP
           SFVec3f             *getSFEulerRotationOrientation(void);
#endif

           SFString            *editSFEulerRotationOrder(void);
     const SFString            *getSFEulerRotationOrder(void) const;
#ifndef OSG_2_PREP
           SFString            *getSFEulerRotationOrder(void);
#endif

           SFUInt64            *editSFFlags          (void);
     const SFUInt64            *getSFFlags          (void) const;
#ifndef OSG_2_PREP
           SFUInt64            *getSFFlags          (void);
#endif


           Vec3f               &editTranslation    (void);
     const Vec3f               &getTranslation    (void) const;
#ifndef OSG_2_PREP
           Vec3f               &getTranslation    (void);
#endif

           Vec3f               &editEulerRotation  (void);
     const Vec3f               &getEulerRotation  (void) const;
#ifndef OSG_2_PREP
           Vec3f               &getEulerRotation  (void);
#endif

           Vec3f               &editScale          (void);
     const Vec3f               &getScale          (void) const;
#ifndef OSG_2_PREP
           Vec3f               &getScale          (void);
#endif

           Quaternion          &editRotation       (void);
     const Quaternion          &getRotation       (void) const;
#ifndef OSG_2_PREP
           Quaternion          &getRotation       (void);
#endif

           Vec3f               &editShear          (void);
     const Vec3f               &getShear          (void) const;
#ifndef OSG_2_PREP
           Vec3f               &getShear          (void);
#endif

           Pnt3f               &editScalePivot     (void);
     const Pnt3f               &getScalePivot     (void) const;
#ifndef OSG_2_PREP
           Pnt3f               &getScalePivot     (void);
#endif

           Vec3f               &editScalePivotTranslation(void);
     const Vec3f               &getScalePivotTranslation(void) const;
#ifndef OSG_2_PREP
           Vec3f               &getScalePivotTranslation(void);
#endif

           Pnt3f               &editRotatePivot    (void);
     const Pnt3f               &getRotatePivot    (void) const;
#ifndef OSG_2_PREP
           Pnt3f               &getRotatePivot    (void);
#endif

           Vec3f               &editRotatePivotTranslation(void);
     const Vec3f               &getRotatePivotTranslation(void) const;
#ifndef OSG_2_PREP
           Vec3f               &getRotatePivotTranslation(void);
#endif

           Quaternion          &editRotationOrientation(void);
     const Quaternion          &getRotationOrientation(void) const;
#ifndef OSG_2_PREP
           Quaternion          &getRotationOrientation(void);
#endif

           Pnt3f               &editCenter         (void);
     const Pnt3f               &getCenter         (void) const;
#ifndef OSG_2_PREP
           Pnt3f               &getCenter         (void);
#endif

           UInt32              &editRotationMode   (void);
     const UInt32              &getRotationMode   (void) const;
#ifndef OSG_2_PREP
           UInt32              &getRotationMode   (void);
#endif

           Real64              &editVersion        (void);
     const Real64              &getVersion        (void) const;
#ifndef OSG_2_PREP
           Real64              &getVersion        (void);
#endif

           Vec3f               &editEulerRotationOrientation(void);
     const Vec3f               &getEulerRotationOrientation(void) const;
#ifndef OSG_2_PREP
           Vec3f               &getEulerRotationOrientation(void);
#endif

           std::string         &editEulerRotationOrder(void);
     const std::string         &getEulerRotationOrder(void) const;
#ifndef OSG_2_PREP
           std::string         &getEulerRotationOrder(void);
#endif

           UInt64              &editFlags          (void);
     const UInt64              &getFlags          (void) const;
#ifndef OSG_2_PREP
           UInt64              &getFlags          (void);
#endif

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Set                                 */
    /*! \{                                                                 */

     void setTranslation    ( const Vec3f &value );
     void setEulerRotation  ( const Vec3f &value );
     void setScale          ( const Vec3f &value );
     void setRotation       ( const Quaternion &value );
     void setShear          ( const Vec3f &value );
     void setScalePivot     ( const Pnt3f &value );
     void setScalePivotTranslation( const Vec3f &value );
     void setRotatePivot    ( const Pnt3f &value );
     void setRotatePivotTranslation( const Vec3f &value );
     void setRotationOrientation( const Quaternion &value );
     void setCenter         ( const Pnt3f &value );
     void setRotationMode   ( const UInt32 &value );
     void setVersion        ( const Real64 &value );
     void setEulerRotationOrientation( const Vec3f &value );
     void setEulerRotationOrder( const std::string &value );
     void setFlags          ( const UInt64 &value );

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Binary Access                              */
    /*! \{                                                                 */

    virtual SizeT  getBinSize (const BitVector         &whichField);
    virtual void   copyToBin  (      BinaryDataHandler &pMem,
                               const BitVector         &whichField);
    virtual void   copyFromBin(      BinaryDataHandler &pMem,
                               const BitVector         &whichField);


    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Construction                               */
    /*! \{                                                                 */

    static  Transform3DPtr      create          (void); 
    static  Transform3DPtr      createEmpty     (void); 

    /*! \}                                                                 */

    /*---------------------------------------------------------------------*/
    /*! \name                       Copy                                   */
    /*! \{                                                                 */

    virtual FieldContainerPtr     shallowCopy     (void) const; 

    /*! \}                                                                 */
    /*=========================  PROTECTED  ===============================*/
  protected:

    /*---------------------------------------------------------------------*/
    /*! \name                      Fields                                  */
    /*! \{                                                                 */

    SFVec3f             _sfTranslation;
    SFVec3f             _sfEulerRotation;
    SFVec3f             _sfScale;
    SFQuaternion        _sfRotation;
    SFVec3f             _sfShear;
    SFPnt3f             _sfScalePivot;
    SFVec3f             _sfScalePivotTranslation;
    SFPnt3f             _sfRotatePivot;
    SFVec3f             _sfRotatePivotTranslation;
    SFQuaternion        _sfRotationOrientation;
    SFPnt3f             _sfCenter;
    SFUInt32            _sfRotationMode;
    SFReal64            _sfVersion;
    SFVec3f             _sfEulerRotationOrientation;
    SFString            _sfEulerRotationOrder;
    SFUInt64            _sfFlags;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Constructors                               */
    /*! \{                                                                 */

    Transform3DBase(void);
    Transform3DBase(const Transform3DBase &source);

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Destructors                                */
    /*! \{                                                                 */

    virtual ~Transform3DBase(void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

#if !defined(OSG_FIXED_MFIELDSYNC)
    void executeSyncImpl(      Transform3DBase *pOther,
                         const BitVector         &whichField);

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField);
#else
    void executeSyncImpl(      Transform3DBase *pOther,
                         const BitVector         &whichField,
                         const SyncInfo          &sInfo     );

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField,
                               const SyncInfo          &sInfo);

    virtual void execBeginEdit     (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

            void execBeginEditImpl (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

    virtual void onDestroyAspect(UInt32 uiId, UInt32 uiAspect);
#endif

    /*! \}                                                                 */
    /*==========================  PRIVATE  ================================*/
  private:

    friend class FieldContainer;

    static FieldDescription   *_desc[];
    static FieldContainerType  _type;


    // prohibit default functions (move to 'public' if you need one)
    void operator =(const Transform3DBase &source);
};

//---------------------------------------------------------------------------
//   Exported Types
//---------------------------------------------------------------------------


typedef Transform3DBase *Transform3DBaseP;

typedef osgIF<Transform3DBase::isNodeCore,
              CoredNodePtr<Transform3D>,
              FieldContainer::attempt_to_create_CoredNodePtr_on_non_NodeCore_FC
              >::_IRet Transform3DNodePtr;

typedef RefPtr<Transform3DPtr> Transform3DRefPtr;

OSG_END_NAMESPACE

#define OSGTRANSFORM3DBASE_HEADER_CVSID "@(#)$Id: FCBaseTemplate_h.h,v 1.42 2008/06/09 12:26:59 vossg Exp $"

#endif /* _OSGTRANSFORM3DBASE_H_ */
