/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class ShadeModelChunk!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILESHADEMODELCHUNKINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGShadeModelChunkBase.h"
#include "OSGShadeModelChunk.h"


OSG_BEGIN_NAMESPACE

const OSG::BitVector  ShadeModelChunkBase::ShadeModelFieldMask = 
    (TypeTraits<BitVector>::One << ShadeModelChunkBase::ShadeModelFieldId);

const OSG::BitVector ShadeModelChunkBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var GLenum          ShadeModelChunkBase::_sfShadeModel
    The shading model to use (glShadeModel).
*/

//! ShadeModelChunk description

FieldDescription *ShadeModelChunkBase::_desc[] = 
{
    new FieldDescription(SFGLenum::getClassType(), 
                     "shadeModel", 
                     ShadeModelFieldId, ShadeModelFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&ShadeModelChunkBase::editSFShadeModel))
};


FieldContainerType ShadeModelChunkBase::_type(
    "ShadeModelChunk",
    "StateChunk",
    NULL,
    reinterpret_cast<PrototypeCreateF>(&ShadeModelChunkBase::createEmpty),
    ShadeModelChunk::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(ShadeModelChunkBase, ShadeModelChunkPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &ShadeModelChunkBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &ShadeModelChunkBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr ShadeModelChunkBase::shallowCopy(void) const 
{ 
    ShadeModelChunkPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const ShadeModelChunk *>(this)); 

    return returnValue; 
}

UInt32 ShadeModelChunkBase::getContainerSize(void) const 
{ 
    return sizeof(ShadeModelChunk); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void ShadeModelChunkBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl(static_cast<ShadeModelChunkBase *>(&other),
                          whichField);
}
#else
void ShadeModelChunkBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((ShadeModelChunkBase *) &other, whichField, sInfo);
}
void ShadeModelChunkBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void ShadeModelChunkBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

ShadeModelChunkBase::ShadeModelChunkBase(void) :
    _sfShadeModel             (GLenum(GL_SMOOTH)), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

ShadeModelChunkBase::ShadeModelChunkBase(const ShadeModelChunkBase &source) :
    _sfShadeModel             (source._sfShadeModel             ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

ShadeModelChunkBase::~ShadeModelChunkBase(void)
{
}

/*------------------------------ access -----------------------------------*/

SizeT  ShadeModelChunkBase::getBinSize(const BitVector &whichField)
{
    SizeT returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (ShadeModelFieldMask & whichField))
    {
        returnValue += _sfShadeModel.getBinSize();
    }


    return returnValue;
}

void ShadeModelChunkBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (ShadeModelFieldMask & whichField))
    {
        _sfShadeModel.copyToBin(pMem);
    }


}

void ShadeModelChunkBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (ShadeModelFieldMask & whichField))
    {
        _sfShadeModel.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void ShadeModelChunkBase::executeSyncImpl(      ShadeModelChunkBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (ShadeModelFieldMask & whichField))
        _sfShadeModel.syncWith(pOther->_sfShadeModel);


}
#else
void ShadeModelChunkBase::executeSyncImpl(      ShadeModelChunkBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (ShadeModelFieldMask & whichField))
        _sfShadeModel.syncWith(pOther->_sfShadeModel);



}

void ShadeModelChunkBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

}
#endif



#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<ShadeModelChunkPtr>::_type("ShadeModelChunkPtr", "StateChunkPtr");
#endif



/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: FCBaseTemplate_cpp.h,v 1.49 2008/06/09 07:30:44 vossg Exp $";
    static Char8 cvsid_hpp       [] = OSGSHADEMODELCHUNKBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGSHADEMODELCHUNKBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGSHADEMODELCHUNKFIELDS_HEADER_CVSID;
}

OSG_END_NAMESPACE

