/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class PerspectiveCamera
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGPERSPECTIVECAMERABASE_H_
#define _OSGPERSPECTIVECAMERABASE_H_
#ifdef __sgi
#pragma once
#endif


#include <OSGConfig.h>
#include <OSGSystemDef.h>

#include <OSGBaseTypes.h>
#include <OSGRefPtr.h>
#include <OSGCoredNodePtr.h>

#include <OSGCamera.h> // Parent

#include <OSGReal32Fields.h> // Fov type
#include <OSGUInt32Fields.h> // FovMode type
#include <OSGReal32Fields.h> // Aspect type

#include <OSGPerspectiveCameraFields.h>

OSG_BEGIN_NAMESPACE

class PerspectiveCamera;
class BinaryDataHandler;

//! \brief PerspectiveCamera Base Class.

class OSG_SYSTEMLIB_DLLMAPPING PerspectiveCameraBase : public Camera
{
  private:

    typedef Camera    Inherited;

    /*==========================  PUBLIC  =================================*/
  public:

    typedef PerspectiveCameraPtr  Ptr;

    enum
    {
        FovFieldId     = Inherited::NextFieldId,
        FovModeFieldId = FovFieldId     + 1,
        AspectFieldId  = FovModeFieldId + 1,
        NextFieldId    = AspectFieldId  + 1
    };

    static const OSG::BitVector FovFieldMask;
    static const OSG::BitVector FovModeFieldMask;
    static const OSG::BitVector AspectFieldMask;


    static const OSG::BitVector MTInfluenceMask;

    /*---------------------------------------------------------------------*/
    /*! \name                    Class Get                                 */
    /*! \{                                                                 */

    static        FieldContainerType &getClassType    (void); 
    static        UInt32              getClassTypeId  (void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                FieldContainer Get                            */
    /*! \{                                                                 */

    virtual       FieldContainerType &getType  (void); 
    virtual const FieldContainerType &getType  (void) const; 

    virtual       UInt32              getContainerSize(void) const;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Get                                 */
    /*! \{                                                                 */


           SFReal32            *editSFFov            (void);
     const SFReal32            *getSFFov            (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFFov            (void);
#endif

           SFUInt32            *editSFFovMode        (void);
     const SFUInt32            *getSFFovMode        (void) const;
#ifndef OSG_2_PREP
           SFUInt32            *getSFFovMode        (void);
#endif

           SFReal32            *editSFAspect         (void);
     const SFReal32            *getSFAspect         (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFAspect         (void);
#endif


           Real32              &editFov            (void);
     const Real32              &getFov            (void) const;
#ifndef OSG_2_PREP
           Real32              &getFov            (void);
#endif

           UInt32              &editFovMode        (void);
     const UInt32              &getFovMode        (void) const;
#ifndef OSG_2_PREP
           UInt32              &getFovMode        (void);
#endif

           Real32              &editAspect         (void);
     const Real32              &getAspect         (void) const;
#ifndef OSG_2_PREP
           Real32              &getAspect         (void);
#endif

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Set                                 */
    /*! \{                                                                 */

     void setFov            ( const Real32 &value );
     void setFovMode        ( const UInt32 &value );
     void setAspect         ( const Real32 &value );

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Binary Access                              */
    /*! \{                                                                 */

    virtual SizeT  getBinSize (const BitVector         &whichField);
    virtual void   copyToBin  (      BinaryDataHandler &pMem,
                               const BitVector         &whichField);
    virtual void   copyFromBin(      BinaryDataHandler &pMem,
                               const BitVector         &whichField);


    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Construction                               */
    /*! \{                                                                 */

    static  PerspectiveCameraPtr      create          (void); 
    static  PerspectiveCameraPtr      createEmpty     (void); 

    /*! \}                                                                 */

    /*---------------------------------------------------------------------*/
    /*! \name                       Copy                                   */
    /*! \{                                                                 */

    virtual FieldContainerPtr     shallowCopy     (void) const; 

    /*! \}                                                                 */
    /*=========================  PROTECTED  ===============================*/
  protected:

    /*---------------------------------------------------------------------*/
    /*! \name                      Fields                                  */
    /*! \{                                                                 */

    SFReal32            _sfFov;
    SFUInt32            _sfFovMode;
    SFReal32            _sfAspect;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Constructors                               */
    /*! \{                                                                 */

    PerspectiveCameraBase(void);
    PerspectiveCameraBase(const PerspectiveCameraBase &source);

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Destructors                                */
    /*! \{                                                                 */

    virtual ~PerspectiveCameraBase(void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

#if !defined(OSG_FIXED_MFIELDSYNC)
    void executeSyncImpl(      PerspectiveCameraBase *pOther,
                         const BitVector         &whichField);

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField);
#else
    void executeSyncImpl(      PerspectiveCameraBase *pOther,
                         const BitVector         &whichField,
                         const SyncInfo          &sInfo     );

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField,
                               const SyncInfo          &sInfo);

    virtual void execBeginEdit     (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

            void execBeginEditImpl (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

    virtual void onDestroyAspect(UInt32 uiId, UInt32 uiAspect);
#endif

    /*! \}                                                                 */
    /*==========================  PRIVATE  ================================*/
  private:

    friend class FieldContainer;

    static FieldDescription   *_desc[];
    static FieldContainerType  _type;


    // prohibit default functions (move to 'public' if you need one)
    void operator =(const PerspectiveCameraBase &source);
};

//---------------------------------------------------------------------------
//   Exported Types
//---------------------------------------------------------------------------


typedef PerspectiveCameraBase *PerspectiveCameraBaseP;

typedef osgIF<PerspectiveCameraBase::isNodeCore,
              CoredNodePtr<PerspectiveCamera>,
              FieldContainer::attempt_to_create_CoredNodePtr_on_non_NodeCore_FC
              >::_IRet PerspectiveCameraNodePtr;

typedef RefPtr<PerspectiveCameraPtr> PerspectiveCameraRefPtr;

OSG_END_NAMESPACE

#define OSGPERSPECTIVECAMERABASE_HEADER_CVSID "@(#)$Id: FCBaseTemplate_h.h,v 1.42 2008/06/09 12:26:59 vossg Exp $"

#endif /* _OSGPERSPECTIVECAMERABASE_H_ */
