/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class SolidBackground
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGSOLIDBACKGROUNDBASE_H_
#define _OSGSOLIDBACKGROUNDBASE_H_
#ifdef __sgi
#pragma once
#endif


#include <OSGConfig.h>
#include <OSGSystemDef.h>

#include <OSGBaseTypes.h>
#include <OSGRefPtr.h>
#include <OSGCoredNodePtr.h>

#include <OSGBackground.h> // Parent

#include <OSGColor3fFields.h> // Color type
#include <OSGInt32Fields.h> // ClearStencilBit type
#include <OSGReal32Fields.h> // Alpha type
#include <OSGReal32Fields.h> // Depth type
#include <OSGBoolFields.h> // ClearDepth type
#include <OSGBoolFields.h> // ClearColor type
#include <OSGColor4fFields.h> // AlphaBackgroundColor type

#include <OSGSolidBackgroundFields.h>

OSG_BEGIN_NAMESPACE

class SolidBackground;
class BinaryDataHandler;

//! \brief SolidBackground Base Class.

class OSG_SYSTEMLIB_DLLMAPPING SolidBackgroundBase : public Background
{
  private:

    typedef Background    Inherited;

    /*==========================  PUBLIC  =================================*/
  public:

    typedef SolidBackgroundPtr  Ptr;

    enum
    {
        ColorFieldId                = Inherited::NextFieldId,
        ClearStencilBitFieldId      = ColorFieldId                + 1,
        AlphaFieldId                = ClearStencilBitFieldId      + 1,
        DepthFieldId                = AlphaFieldId                + 1,
        ClearDepthFieldId           = DepthFieldId                + 1,
        ClearColorFieldId           = ClearDepthFieldId           + 1,
        AlphaBackgroundColorFieldId = ClearColorFieldId           + 1,
        NextFieldId                 = AlphaBackgroundColorFieldId + 1
    };

    static const OSG::BitVector ColorFieldMask;
    static const OSG::BitVector ClearStencilBitFieldMask;
    static const OSG::BitVector AlphaFieldMask;
    static const OSG::BitVector DepthFieldMask;
    static const OSG::BitVector ClearDepthFieldMask;
    static const OSG::BitVector ClearColorFieldMask;
    static const OSG::BitVector AlphaBackgroundColorFieldMask;


    static const OSG::BitVector MTInfluenceMask;

    /*---------------------------------------------------------------------*/
    /*! \name                    Class Get                                 */
    /*! \{                                                                 */

    static        FieldContainerType &getClassType    (void); 
    static        UInt32              getClassTypeId  (void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                FieldContainer Get                            */
    /*! \{                                                                 */

    virtual       FieldContainerType &getType  (void); 
    virtual const FieldContainerType &getType  (void) const; 

    virtual       UInt32              getContainerSize(void) const;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Get                                 */
    /*! \{                                                                 */


           SFColor3f           *editSFColor          (void);
     const SFColor3f           *getSFColor          (void) const;
#ifndef OSG_2_PREP
           SFColor3f           *getSFColor          (void);
#endif

           SFInt32             *editSFClearStencilBit(void);
     const SFInt32             *getSFClearStencilBit(void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFClearStencilBit(void);
#endif

           SFReal32            *editSFAlpha          (void);
     const SFReal32            *getSFAlpha          (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFAlpha          (void);
#endif

           SFReal32            *editSFDepth          (void);
     const SFReal32            *getSFDepth          (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFDepth          (void);
#endif

           SFBool              *editSFClearDepth     (void);
     const SFBool              *getSFClearDepth     (void) const;
#ifndef OSG_2_PREP
           SFBool              *getSFClearDepth     (void);
#endif

           SFBool              *editSFClearColor     (void);
     const SFBool              *getSFClearColor     (void) const;
#ifndef OSG_2_PREP
           SFBool              *getSFClearColor     (void);
#endif

           SFColor4f           *editSFAlphaBackgroundColor(void);
     const SFColor4f           *getSFAlphaBackgroundColor(void) const;
#ifndef OSG_2_PREP
           SFColor4f           *getSFAlphaBackgroundColor(void);
#endif


           Color3f             &editColor          (void);
     const Color3f             &getColor          (void) const;
#ifndef OSG_2_PREP
           Color3f             &getColor          (void);
#endif

           Int32               &editClearStencilBit(void);
     const Int32               &getClearStencilBit(void) const;
#ifndef OSG_2_PREP
           Int32               &getClearStencilBit(void);
#endif

           Real32              &editAlpha          (void);
     const Real32              &getAlpha          (void) const;
#ifndef OSG_2_PREP
           Real32              &getAlpha          (void);
#endif

           Real32              &editDepth          (void);
     const Real32              &getDepth          (void) const;
#ifndef OSG_2_PREP
           Real32              &getDepth          (void);
#endif

           bool                &editClearDepth     (void);
     const bool                &getClearDepth     (void) const;
#ifndef OSG_2_PREP
           bool                &getClearDepth     (void);
#endif

           bool                &editClearColor     (void);
     const bool                &getClearColor     (void) const;
#ifndef OSG_2_PREP
           bool                &getClearColor     (void);
#endif

           Color4f             &editAlphaBackgroundColor(void);
     const Color4f             &getAlphaBackgroundColor(void) const;
#ifndef OSG_2_PREP
           Color4f             &getAlphaBackgroundColor(void);
#endif

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Set                                 */
    /*! \{                                                                 */

     void setColor          ( const Color3f &value );
     void setClearStencilBit( const Int32 &value );
     void setAlpha          ( const Real32 &value );
     void setDepth          ( const Real32 &value );
     void setClearDepth     ( const bool &value );
     void setClearColor     ( const bool &value );
     void setAlphaBackgroundColor( const Color4f &value );

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Binary Access                              */
    /*! \{                                                                 */

    virtual SizeT  getBinSize (const BitVector         &whichField);
    virtual void   copyToBin  (      BinaryDataHandler &pMem,
                               const BitVector         &whichField);
    virtual void   copyFromBin(      BinaryDataHandler &pMem,
                               const BitVector         &whichField);


    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Construction                               */
    /*! \{                                                                 */

    static  SolidBackgroundPtr      create          (void); 
    static  SolidBackgroundPtr      createEmpty     (void); 

    /*! \}                                                                 */

    /*---------------------------------------------------------------------*/
    /*! \name                       Copy                                   */
    /*! \{                                                                 */

    virtual FieldContainerPtr     shallowCopy     (void) const; 

    /*! \}                                                                 */
    /*=========================  PROTECTED  ===============================*/
  protected:

    /*---------------------------------------------------------------------*/
    /*! \name                      Fields                                  */
    /*! \{                                                                 */

    SFColor3f           _sfColor;
    SFInt32             _sfClearStencilBit;
    SFReal32            _sfAlpha;
    SFReal32            _sfDepth;
    SFBool              _sfClearDepth;
    SFBool              _sfClearColor;
    SFColor4f           _sfAlphaBackgroundColor;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Constructors                               */
    /*! \{                                                                 */

    SolidBackgroundBase(void);
    SolidBackgroundBase(const SolidBackgroundBase &source);

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Destructors                                */
    /*! \{                                                                 */

    virtual ~SolidBackgroundBase(void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

#if !defined(OSG_FIXED_MFIELDSYNC)
    void executeSyncImpl(      SolidBackgroundBase *pOther,
                         const BitVector         &whichField);

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField);
#else
    void executeSyncImpl(      SolidBackgroundBase *pOther,
                         const BitVector         &whichField,
                         const SyncInfo          &sInfo     );

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField,
                               const SyncInfo          &sInfo);

    virtual void execBeginEdit     (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

            void execBeginEditImpl (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

    virtual void onDestroyAspect(UInt32 uiId, UInt32 uiAspect);
#endif

    /*! \}                                                                 */
    /*==========================  PRIVATE  ================================*/
  private:

    friend class FieldContainer;

    static FieldDescription   *_desc[];
    static FieldContainerType  _type;


    // prohibit default functions (move to 'public' if you need one)
    void operator =(const SolidBackgroundBase &source);
};

//---------------------------------------------------------------------------
//   Exported Types
//---------------------------------------------------------------------------


typedef SolidBackgroundBase *SolidBackgroundBaseP;

typedef osgIF<SolidBackgroundBase::isNodeCore,
              CoredNodePtr<SolidBackground>,
              FieldContainer::attempt_to_create_CoredNodePtr_on_non_NodeCore_FC
              >::_IRet SolidBackgroundNodePtr;

typedef RefPtr<SolidBackgroundPtr> SolidBackgroundRefPtr;

OSG_END_NAMESPACE

#define OSGSOLIDBACKGROUNDBASE_HEADER_CVSID "@(#)$Id: FCBaseTemplate_h.h,v 1.42 2008/06/09 12:26:59 vossg Exp $"

#endif /* _OSGSOLIDBACKGROUNDBASE_H_ */
